https://bugs.gentoo.org/869401
https://github.com/boostorg/config/commit/f0af4a9184457939b89110795ae2d293582c5f66
https://github.com/boostorg/container_hash/issues/24

From: jzmaddock <john@johnmaddock.co.uk>
Date: Mon, 11 Jul 2022 18:26:07 +0100
Subject: [PATCH] The std lib unary/binary_function base classes are
 deprecated/removed from libcpp15. Fixes
 https://github.com/boostorg/container_hash/issues/24.

--- a/boost/config/stdlib/libcpp.hpp
+++ b/boost/config/stdlib/libcpp.hpp
@@ -168,4 +168,13 @@
 #  define BOOST_NO_CXX14_HDR_SHARED_MUTEX
 #endif
 
+#if _LIBCPP_VERSION >= 15000
+//
+// Unary function is now deprecated in C++11 and later:
+//
+#if __cplusplus >= 201103L
+#define BOOST_NO_CXX98_FUNCTION_BASE
+#endif
+#endif
+
 //  --- end ---

